278. First Bad Version

题目

You are a product manager and currently leading a team to develop a new product. Unfortunately, the latest version of your product fails the quality check. Since each version is developed based on the previous version, all the versions after a bad version are also bad.

Suppose you have n versions [1, 2, ..., n] and you want to find out the first bad one, which causes all the following ones to be bad.

You are given an API bool isBadVersion(version) which will return whether version is bad. Implement a function to find the first bad version. You should minimize the number of calls to the API.


分析

1 找出一个序列中第一个出错的位置,可以理解位这个序列是有序的,利用二分查找找到第一个位置

2 二分查找在处理的时候,如果不是,start = mid + 1;  是的话应该直接赋值start, 因为这时候这个值有可能就是第一个值

3 为什么要用 start + (end - start)/2 这种写法,而不是直接用(start + end)/2

   这是为了防止大数溢出,假设这时候start已经是一个很大的数了,就会产生溢出


代码

public class Solution extends VersionControl {
    public int firstBadVersion(int n) {
        int start = 1, end = n;
        while (start < end){
            int mid = start + (end - start)/2;
            if(!isBadVersion(mid))  start = mid + 1;
            else end = mid;
        }
        return start;    
    }
}

你可能感兴趣的:(LeetCode)